#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "editop") {&editop;}
if ($q->param('fct') eq "admin") {&editop;}
if ($q->param('fct') eq "diroperation") {&diroperation;}


sub diroperation
{

$lv = $q->param('lv');
$ct = $q->param('ct');
$rid = $q->param('rid');
$cid = $q->param('cid');
$prev_cid = $q->param('prev_cid');

#print "LV: $lv<BR>
#CT: $ct<BR>
#RID: $rid<BR>
#CID: $cid<BR>
#PREVCID: $prev_cid<BR>";

$oper = $q->param('oper');

if ($oper eq "edit")
	{
print qq[
<html>
<head>
<title>Edit</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin2.cgi?fct=edit_dir&lv=$lv&ct=$ct&cid=$cid&prev_cid=$prev_cid">
</head>
<body>
</body>
</html>];
exit;
	}
elsif ($oper eq "move")
	{
print qq[<html>
<head>
<title>Edit</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin62.cgi?lv=$lv&ct=$ct&cid=$cid&rid=$rid&prev_cid=$prev_cid">
</head>
<body>
</body>
</html>];
	}
elsif ($oper eq "delete")
	{
print qq[<html>
<head>
<title>Edit</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin2.cgi?fct=delete_dir&lv=$lv&ct=$ct&cid=$cid&rid=$rid&prev_cid=$prev_cid">
</head>
<body>
</body>
</html>];
	}
elsif ($oper eq "generate")
	{
print qq[<html>
<head>
<title>Edit</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/generate.cgi?fct=part_build&cid=$cid">
</head>
<body>
</body>
</html>];
	}


}




sub editop
{

$lv = $q->param('lv');
$ct = $q->param('ct');

$rid = acs::get_rid($ct);

@cid_items = split (/-/, $ct);

$lvc = 1;
foreach $item (@cid_items)
	{
	$decoded_dir = acs::decode_dir($item);
	$dir_display = $dir_display . $decoded_dir . " > ";
	
	$decoded_dir =~ s/'/\\'/g;
	$where_sql = $where_sql . " (l" . $lvc . " = '$decoded_dir') AND";
	
	
	
	$encoded_cat = $encoded_cat . $item . "-";
	push(@allcatlv, $where_sql); 
	
	$lvc++;
	}
	$where_sql = substr($where_sql, 0, length($where_sql) - 3);

	
	$prevcid_sql = $allcatlv[$lvc-3];
	$prevcid_sql = substr($prevcid_sql, 0, length($prevcid_sql) - 3);
	$prevcid_lv = $lvc - 2;



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sth = $dbh->prepare("SELECT cid, crosslinkid FROM dirs WHERE $where_sql AND (level = '$lv')");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows(); 

while ( @row = $sth->fetchrow() )
	{ 
	$realcid = $row[0];
	$crosslinkid = $row[1];
	}

if ($prevcid_lv != 0)
{
$sth = $dbh->prepare("SELECT cid FROM dirs WHERE $prevcid_sql AND (level = '$prevcid_lv')");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows(); 
while ( @row = $sth->fetchrow() )
	{ 
	$real_prevcid = $row[0];
	}
}

$sth->finish;
$dbh->disconnect;

$dir_display = "Root > " . $dir_display;
$dir_display = substr($dir_display, 0, length($dir_display) - 2);


#print "CIDSQL: $where_sql<BR>LEVEL: $lv<BR><BR><BR>";
#print "PREV: $prevcid_sql <BR> LEVEL: $prevcid_lv<BR><BR><BR>";
#print "RID: $rid<BR>";
#print "CID: $realcid<BR>";
#print "PREVCID: $real_prevcid<BR>";

if ($q->param('fct') eq "admin") 
{
print qq[
<html>
<head>
<title>Edit</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin2.cgi?lv=$lv&ct=$ct&cid=$realcid&rid=$rid">
</head>
<body>
</body>
</html>];
exit;

}
else
{

if ($crosslinkid > 0)
	{
	
$headingd = acs::get_heading_box("$web_url/add.gif", "Category/Directory Functions", qq[<p>Choose an Option Below for Crosslinked Category/Directory: <br>
<img src="$web_url/dircross.gif"> <strong>$dir_display</strong></p>
<form method="POST" action="$admin_url/admin70.cgi">
  <p><input type="radio" value="edit" name="oper"
  checked> Edit this Crosslinked Directory <br>
  <input type="radio" value="delete" name="oper"> Delete this Crosslinked Directory </p>
  <p><input type="submit" value="   Go   " name="B1"> 
    <input type="hidden" name="fct" value="diroperation">
    <input type="hidden" name="cid"
  value="$realcid">
    <input type="hidden" name="prev_cid" value="$real_prevcid">
    <input
  type="hidden" name="rid" value="$rid">
    <input type="hidden" name="ct" value="$ct">
    <input
  type="hidden" name="lv" value="$lv">
  </p>
</form>
]);
	
print qq[

<html>
<head>
<title>Category/Directory Functions</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$headingd
</body>
</html>

];
	}
	else
	{

$headingd = acs::get_heading_box("$web_url/add.gif", "Category/Directory Functions", qq[
<p>Choose an Option Below for Category/Directory: <br>
<strong>$dir_display </strong></p>
<form method="POST" action="$admin_url/admin70.cgi">
  <p><input type="radio" value="edit" name="oper"
  checked> Edit this Directory <br>
  <input type="radio" value="move" name="oper"> Move this Directory <br>
  <input type="radio" value="delete" name="oper"> Delete this Directory <br>
  <input type="radio" value="generate" name="oper"> Generate this Directory </p>
  <p><input type="submit" value="   Go   " name="B1">
    <input type="hidden" name="fct" value="diroperation">
    <input type="hidden" name="cid"
  value="$realcid">
    <input type="hidden" name="prev_cid" value="$real_prevcid">
    <input
  type="hidden" name="rid" value="$rid">
    <input type="hidden" name="ct" value="$ct">
    <input
  type="hidden" name="lv" value="$lv">
  </p>
</form>
]);

	
print qq[
<html>
<head>
<title>Directory Functions</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$headingd
</body>
</html>
];
}
}


}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

